import { Selector, createSelector } from '@ngrx/store';
import { Zone, DiscoverHost, Port, Host, DiscoverPort, DiscoverService } from '@overflow/model/discovery';

export interface State {
  zone: Zone | null;
  host: Host | null;
  port: Port | null;
  discoverHost: DiscoverHost | null;
  discoverPort: DiscoverPort | null;
  discoverService: DiscoverService | null;
}

export const initialState: State = {
  zone: null,
  host: null,
  port: null,
  discoverHost: null,
  discoverPort: null,
  discoverService: null,
};


export function getSelectors<S>(selector: Selector<any, State>) {
  return {
    selectZone: createSelector(selector, (state: State) => state.zone),
    selectHost: createSelector(selector, (state: State) => state.host),
    selectPort: createSelector(selector, (state: State) => state.port),
    selectDiscoverHost: createSelector(selector, (state: State) => state.discoverHost),
    selectDiscoverPort: createSelector(selector, (state: State) => state.discoverPort),
    selectDiscoverService: createSelector(selector, (state: State) => state.discoverService),
  };
}
