import { Action } from '@ngrx/store';

export enum ActionType {
  ChangeBlockAppContent = '[app.ui.layout] ChangeBlockAppContent',
  ChangeBlockPagesContent = '[app.ui.layout] ChangeBlockPagesContent',
}

export class ChangeBlockAppContent implements Action {
  readonly type = ActionType.ChangeBlockAppContent;

  constructor(public payload: { blockAppContent: boolean }) { }
}

export class ChangeBlockPagesContent implements Action {
  readonly type = ActionType.ChangeBlockPagesContent;

  constructor(public payload: { blockPagesContent: boolean }) { }
}

export type Actions =
  | ChangeBlockAppContent
  | ChangeBlockPagesContent

  ;
