import { Selector, createSelector } from '@ngrx/store';

export interface State {
  blockAppContent: boolean;
  blockPagesContent: boolean;
}

export const initialState: State = {
  blockAppContent: false,
  blockPagesContent: false,
};

export function getSelectors<S>(selector: Selector<any, State>) {
  return {
    selectBlockAppContent: createSelector(selector, (state: State) => state.blockAppContent),
    selectBlockPagesContent: createSelector(selector, (state: State) => state.blockPagesContent),
  };
}
